#!/usr/bin/env python
"""Program zloadrace.py demonstrates concurrency bug in ZODB Connection.setstate()
that leads to XXX

XXX

XXX load vs invalidation race is there on ZODB4 and ZODB3, but on ZODB5 there is
another open vs invalidation race.
"""

from ZODB import DB
import transaction
from persistent import Persistent

from wendelin.lib.testing import TestDB_ZEO, TestDB_NEO

from golang import sync, context


# PInt is persistent integer.
class PInt(Persistent):
    def __init__(self, i):
        self.i = i

@func
def main():
    tdb = TestDB_ZEO('<zeo>')
    #tdb = TestDB_NEO('<neo>')

    tdb.setup()
    # XXX defer(tdb.teardown)

    # two ZODB client storage connections to the same server
    zstor1 = tdb.getZODBStorage()   # ; defer(zstor1.close)
    zstor2 = tdb.getZODBStorage()   # ; defer(zstor2.close)

    db1 = DB(zstor1)
    db2 = DB(zstor2)


    # XXX doc
    def init():
        transaction.begin()
        zconn = db.open()

        root = zconn.root()
        root['obj1'] = PInt(0)
        root['obj2'] = PInt(0)

        transaction.commit()
        zconn.close()


    def C1(ctx, N):
        # XXX


    def C2(ctx, N):
        # XXX




    init()

    N = 1000
    wg = sync.WorkGroup(context.background())
    wg.go(C1, N)
    wg.go(C2, N)
    wg.wait()


if __name__ == '__main__':
    main()
